diff --git a/src/backend/access/heap/heapam.c b/src/backend/access/heap/heapam.c
index b061d2de85..0f55b77f76 100644
--- a/src/backend/access/heap/heapam.c
+++ b/src/backend/access/heap/heapam.c
@@ -56,6 +56,7 @@
 #include "access/xlogutils.h"
 #include "catalog/catalog.h"
 #include "catalog/namespace.h"
+#include "commands/vacuum.h"
 #include "miscadmin.h"
 #include "pgstat.h"
 #include "port/atomics.h"
@@ -93,7 +94,7 @@ static HeapScanDesc heap_beginscan_internal(Relation relation,
 static void heap_parallelscan_startblock_init(HeapScanDesc scan);
 static BlockNumber heap_parallelscan_nextpage(HeapScanDesc scan);
 static HeapTuple heap_prepare_insert(Relation relation, HeapTuple tup,
-					TransactionId xid, CommandId cid, int options);
+					CommandId cid, int options);
 static XLogRecPtr log_heap_update(Relation reln, Buffer oldbuf,
 				Buffer newbuf, HeapTuple oldtup,
 				HeapTuple newtup, HeapTuple old_key_tup,
@@ -433,6 +434,7 @@ heapgetpage(HeapScanDesc scan, BlockNumber page)
 			loctup.t_tableOid = RelationGetRelid(scan->rs_rd);
 			loctup.t_data = (HeapTupleHeader) PageGetItem((Page) dp, lpp);
 			loctup.t_len = ItemIdGetLength(lpp);
+			HeapTupleCopyBaseFromPage(&loctup, dp);
 			ItemPointerSet(&(loctup.t_self), page, lineoff);
 
 			if (all_visible)
@@ -629,6 +631,7 @@ heapgettup(HeapScanDesc scan,
 
 		tuple->t_data = (HeapTupleHeader) PageGetItem((Page) dp, lpp);
 		tuple->t_len = ItemIdGetLength(lpp);
+		HeapTupleCopyBaseFromPage(tuple, dp);
 
 		return;
 	}
@@ -648,6 +651,7 @@ heapgettup(HeapScanDesc scan,
 
 				tuple->t_data = (HeapTupleHeader) PageGetItem((Page) dp, lpp);
 				tuple->t_len = ItemIdGetLength(lpp);
+				HeapTupleCopyBaseFromPage(tuple, dp);
 				ItemPointerSet(&(tuple->t_self), page, lineoff);
 
 				/*
@@ -927,6 +931,7 @@ heapgettup_pagemode(HeapScanDesc scan,
 
 		tuple->t_data = (HeapTupleHeader) PageGetItem((Page) dp, lpp);
 		tuple->t_len = ItemIdGetLength(lpp);
+		HeapTupleCopyBaseFromPage(tuple, dp);
 
 		/* check that rs_cindex is in sync */
 		Assert(scan->rs_cindex < scan->rs_ntuples);
@@ -949,6 +954,7 @@ heapgettup_pagemode(HeapScanDesc scan,
 
 			tuple->t_data = (HeapTupleHeader) PageGetItem((Page) dp, lpp);
 			tuple->t_len = ItemIdGetLength(lpp);
+			HeapTupleCopyBaseFromPage(tuple, dp);
 			ItemPointerSet(&(tuple->t_self), page, lineoff);
 
 			/*
@@ -1946,6 +1952,7 @@ heap_fetch(Relation relation,
 	tuple->t_data = (HeapTupleHeader) PageGetItem(page, lp);
 	tuple->t_len = ItemIdGetLength(lp);
 	tuple->t_tableOid = RelationGetRelid(relation);
+	HeapTupleCopyBaseFromPage(tuple, page);
 
 	/*
 	 * check time qualification of tuple, then release lock
@@ -2031,6 +2038,7 @@ heap_hot_search_buffer(ItemPointer tid, Relation relation, Buffer buffer,
 	skip = !first_call;
 
 	heapTuple->t_self = *tid;
+	HeapTupleCopyBaseFromPage(heapTuple, dp);
 
 	/* Scan through possible multiple members of HOT-chain */
 	for (;;)
@@ -2061,6 +2069,7 @@ heap_hot_search_buffer(ItemPointer tid, Relation relation, Buffer buffer,
 		heapTuple->t_data = (HeapTupleHeader) PageGetItem(dp, lp);
 		heapTuple->t_len = ItemIdGetLength(lp);
 		heapTuple->t_tableOid = RelationGetRelid(relation);
+		HeapTupleCopyBaseFromPage(heapTuple, dp);
 		ItemPointerSetOffsetNumber(&heapTuple->t_self, offnum);
 
 		/*
@@ -2075,7 +2084,7 @@ heap_hot_search_buffer(ItemPointer tid, Relation relation, Buffer buffer,
 		 */
 		if (TransactionIdIsValid(prev_xmax) &&
 			!TransactionIdEquals(prev_xmax,
-								 HeapTupleHeaderGetXmin(heapTuple->t_data)))
+								 HeapTupleGetXmin(heapTuple)))
 			break;
 
 		/*
@@ -2136,7 +2145,7 @@ heap_hot_search_buffer(ItemPointer tid, Relation relation, Buffer buffer,
 				   ItemPointerGetBlockNumber(tid));
 			offnum = ItemPointerGetOffsetNumber(&heapTuple->t_data->t_ctid);
 			at_chain_start = false;
-			prev_xmax = HeapTupleHeaderGetUpdateXid(heapTuple->t_data);
+			prev_xmax = HeapTupleGetUpdateXidAny(heapTuple);
 		}
 		else
 			break;				/* end of chain */
@@ -2255,13 +2264,14 @@ heap_get_latest_tid(Relation relation,
 		tp.t_data = (HeapTupleHeader) PageGetItem(page, lp);
 		tp.t_len = ItemIdGetLength(lp);
 		tp.t_tableOid = RelationGetRelid(relation);
+		HeapTupleCopyBaseFromPage(&tp, page);
 
 		/*
 		 * After following a t_ctid link, we might arrive at an unrelated
 		 * tuple.  Check for XMIN match.
 		 */
 		if (TransactionIdIsValid(priorXmax) &&
-			!TransactionIdEquals(priorXmax, HeapTupleHeaderGetXmin(tp.t_data)))
+			!TransactionIdEquals(priorXmax, HeapTupleGetXmin(&tp)))
 		{
 			UnlockReleaseBuffer(buffer);
 			break;
@@ -2280,7 +2290,7 @@ heap_get_latest_tid(Relation relation,
 		 * If there's a valid t_ctid link, follow it, else we're done.
 		 */
 		if ((tp.t_data->t_infomask & HEAP_XMAX_INVALID) ||
-			HeapTupleHeaderIsOnlyLocked(tp.t_data) ||
+			HeapTupleHeaderIsOnlyLocked(&tp) ||
 			ItemPointerEquals(&tp.t_self, &tp.t_data->t_ctid))
 		{
 			UnlockReleaseBuffer(buffer);
@@ -2288,7 +2298,7 @@ heap_get_latest_tid(Relation relation,
 		}
 
 		ctid = tp.t_data->t_ctid;
-		priorXmax = HeapTupleHeaderGetUpdateXid(tp.t_data);
+		priorXmax = HeapTupleGetUpdateXidAny(&tp);
 		UnlockReleaseBuffer(buffer);
 	}							/* end of loop */
 }
@@ -2313,7 +2323,7 @@ heap_get_latest_tid(Relation relation,
 static void
 UpdateXmaxHintBits(HeapTupleHeader tuple, Buffer buffer, TransactionId xid)
 {
-	Assert(TransactionIdEquals(HeapTupleHeaderGetRawXmax(tuple), xid));
+	Assert(TransactionIdEquals(HeapTupleHeaderGetRawXmax(BufferGetPage(buffer), tuple), xid));
 	Assert(!(tuple->t_infomask & HEAP_XMAX_IS_MULTI));
 
 	if (!(tuple->t_infomask & (HEAP_XMAX_COMMITTED | HEAP_XMAX_INVALID)))
@@ -2426,7 +2436,7 @@ heap_insert(Relation relation, HeapTuple tup, CommandId cid,
 	 * Note: below this point, heaptup is the data we actually intend to store
 	 * into the relation; tup is the caller's original untoasted data.
 	 */
-	heaptup = heap_prepare_insert(relation, tup, xid, cid, options);
+	heaptup = heap_prepare_insert(relation, tup, cid, options);
 
 	/*
 	 * Find buffer to insert this tuple into.  If the page is all visible,
@@ -2453,11 +2463,14 @@ heap_insert(Relation relation, HeapTuple tup, CommandId cid,
 	 */
 	CheckForSerializableConflictIn(relation, NULL, InvalidBuffer);
 
+	heap_page_prepare_for_xid(relation, buffer, xid, false);
+	HeapTupleCopyBaseFromPage(heaptup, BufferGetPage(buffer));
+
 	/* NO EREPORT(ERROR) from here till changes are logged */
 	START_CRIT_SECTION();
 
 	RelationPutHeapTuple(relation, buffer, heaptup,
-						 (options & HEAP_INSERT_SPECULATIVE) != 0);
+						 (options & HEAP_INSERT_SPECULATIVE) != 0, xid);
 
 	if (PageIsAllVisible(BufferGetPage(buffer)))
 	{
@@ -2530,6 +2543,10 @@ heap_insert(Relation relation, HeapTuple tup, CommandId cid,
 		}
 
 		XLogBeginInsert();
+		if (info & XLOG_HEAP_INIT_PAGE)
+		{
+			XLogRegisterData((char *) &HeapPageGetSpecial(page)->pd_xid_base, sizeof(TransactionId));
+		}
 		XLogRegisterData((char *) &xlrec, SizeOfHeapInsert);
 
 		xlhdr.t_infomask2 = heaptup->t_data->t_infomask2;
@@ -2586,6 +2603,460 @@ heap_insert(Relation relation, HeapTuple tup, CommandId cid,
 	return HeapTupleGetOid(tup);
 }
 
+/*
+ * Find minimum and maximum short transaction ids which occurs in the page.
+ */
+static bool
+heap_page_xid_min_max(Page page, bool multi,
+					  ShortTransactionId *min,
+					  ShortTransactionId *max)
+{
+	bool				found = false;
+	OffsetNumber		offnum,
+						maxoff;
+
+	maxoff = PageGetMaxOffsetNumber(page);
+
+	for (offnum = FirstOffsetNumber;
+		 offnum <= maxoff;
+		 offnum = OffsetNumberNext(offnum))
+	{
+		ItemId				itemid;
+		HeapTupleHeader		htup;
+
+		itemid = PageGetItemId(page, offnum);
+
+		if (!ItemIdIsNormal(itemid))
+			continue;
+
+		htup = (HeapTupleHeader) PageGetItem(page, itemid);
+
+		if (!multi)
+		{
+			if (!HeapTupleHeaderXminFrozen(htup) &&
+				TransactionIdIsNormal(htup->t_choice.t_heap.t_xmin))
+			{
+				if (!found)
+				{
+					*min = *max = htup->t_choice.t_heap.t_xmin;
+					found = true;
+				}
+				else
+				{
+					*min = Min(*min, htup->t_choice.t_heap.t_xmin);
+					*max = Max(*max, htup->t_choice.t_heap.t_xmin);
+				}
+			}
+
+			if (TransactionIdIsNormal(htup->t_choice.t_heap.t_xmax) &&
+				!(htup->t_infomask & HEAP_XMAX_IS_MULTI))
+			{
+				if (!found)
+				{
+					*min = *max = htup->t_choice.t_heap.t_xmax;
+					found = true;
+				}
+				else
+				{
+					*min = Min(*min, htup->t_choice.t_heap.t_xmax);
+					*max = Max(*max, htup->t_choice.t_heap.t_xmax);
+				}
+			}
+		}
+		else
+		{
+			if (TransactionIdIsNormal(htup->t_choice.t_heap.t_xmax) &&
+				(htup->t_infomask & HEAP_XMAX_IS_MULTI))
+			{
+				if (!found)
+				{
+					*min = *max = htup->t_choice.t_heap.t_xmax;
+					found = true;
+				}
+				else
+				{
+					*min = Min(*min, htup->t_choice.t_heap.t_xmax);
+					*max = Max(*max, htup->t_choice.t_heap.t_xmax);
+				}
+			}
+		}
+	}
+	return found;
+}
+
+/*
+ * Shift xid base in the page.  WAL-logged if buffer is specified.
+ */
+static void
+heap_page_shift_base(Relation relation, Buffer buffer, Page page, bool multi, int64 delta)
+{
+	HeapPageSpecial		pageSpecial = HeapPageGetSpecial(page);
+	OffsetNumber		offnum,
+						maxoff;
+
+	START_CRIT_SECTION();
+
+	/* Iterate over page items */
+	maxoff = PageGetMaxOffsetNumber(page);
+	for (offnum = FirstOffsetNumber;
+		 offnum <= maxoff;
+		 offnum = OffsetNumberNext(offnum))
+	{
+		ItemId				itemid;
+		HeapTupleHeader		htup;
+
+		itemid = PageGetItemId(page, offnum);
+
+		if (!ItemIdIsNormal(itemid))
+			continue;
+
+		htup = (HeapTupleHeader) PageGetItem(page, itemid);
+
+		/* Apply xid shift to heap tuple */
+		if (!multi)
+		{
+			if (!HeapTupleHeaderXminFrozen(htup) &&
+				TransactionIdIsNormal(htup->t_choice.t_heap.t_xmin))
+			{
+				Assert(htup->t_choice.t_heap.t_xmin - delta >= FirstNormalTransactionId);
+				Assert(htup->t_choice.t_heap.t_xmin - delta <= MaxShortTransactionId);
+				htup->t_choice.t_heap.t_xmin -= delta;
+			}
+
+			if (TransactionIdIsNormal(htup->t_choice.t_heap.t_xmax) &&
+				!(htup->t_infomask & HEAP_XMAX_IS_MULTI))
+			{
+				Assert(htup->t_choice.t_heap.t_xmax - delta >= FirstNormalTransactionId);
+				Assert(htup->t_choice.t_heap.t_xmax - delta <= MaxShortTransactionId);
+				htup->t_choice.t_heap.t_xmax -= delta;
+			}
+		}
+		else
+		{
+			if (TransactionIdIsNormal(htup->t_choice.t_heap.t_xmax) &&
+				(htup->t_infomask & HEAP_XMAX_IS_MULTI))
+			{
+				Assert(htup->t_choice.t_heap.t_xmax - delta >= FirstNormalTransactionId);
+				Assert(htup->t_choice.t_heap.t_xmax - delta <= MaxShortTransactionId);
+				htup->t_choice.t_heap.t_xmax -= delta;
+			}
+		}
+	}
+
+	/* Apply xid shift to base as well */
+	if (!multi)
+		pageSpecial->pd_xid_base += delta;
+	else
+		pageSpecial->pd_multi_base += delta;
+
+	if (BufferIsValid(buffer))
+		MarkBufferDirty(buffer);
+
+	/* Write WAL record if needed */
+	if (relation && RelationNeedsWAL(relation))
+	{
+		XLogRecPtr			recptr;
+		xl_heap_base_shift	xlrec;
+
+		xlrec.multi = multi;
+		xlrec.delta = delta;
+
+		XLogBeginInsert();
+		XLogRegisterData((char *) &xlrec, SizeOfHeapBaseShift);
+
+		XLogRegisterBuffer(0, buffer, REGBUF_STANDARD);
+
+		recptr = XLogInsert(RM_HEAP_ID, XLOG_HEAP_BASE_SHIFT);
+
+		PageSetLSN(page, recptr);
+	}
+
+	END_CRIT_SECTION();
+}
+
+/*
+ * Freeze xids in the single heap page.  Useful when we can't fit new xid even
+ * with base shift.
+ */
+static int
+freeze_single_heap_page(Relation relation, Buffer buffer)
+{
+	Page					page = BufferGetPage(buffer);
+	OffsetNumber			offnum,
+							maxoff;
+	HeapTupleData			tuple;
+	int						nfrozen = 0;
+	xl_heap_freeze_tuple   *frozen;
+	TransactionId			latestRemovedXid = InvalidTransactionId,
+							relfrozenxid = relation->rd_rel->relfrozenxid,
+							relminmxid = relation->rd_rel->relminmxid,
+							OldestXmin,
+							FreezeXid;
+	MultiXactId				MultiXactCutoff;
+
+	vacuum_set_xid_limits(relation, 0, 0, 0, 0,
+						  &OldestXmin, &FreezeXid, NULL, &MultiXactCutoff,
+						  NULL);
+
+	heap_page_prune(relation, buffer, OldestXmin, false, &latestRemovedXid, false);
+
+	/*
+	 * Now scan the page to collect vacuumable items and check for tuples
+	 * requiring freezing.
+	 */
+	maxoff = PageGetMaxOffsetNumber(page);
+	frozen = palloc(sizeof(xl_heap_freeze_tuple) * MaxHeapTuplesPerPage);
+
+	/*
+	 * Note: If you change anything in the loop below, also look at
+	 * heap_page_is_all_visible to see if that needs to be changed.
+	 */
+	for (offnum = FirstOffsetNumber;
+		 offnum <= maxoff;
+		 offnum = OffsetNumberNext(offnum))
+	{
+		ItemId		itemid;
+		bool		tuple_totally_frozen;
+
+		itemid = PageGetItemId(page, offnum);
+
+		if (!ItemIdIsNormal(itemid))
+			continue;
+
+		Assert(ItemIdIsNormal(itemid));
+
+		tuple.t_data = (HeapTupleHeader) PageGetItem(page, itemid);
+		tuple.t_len = ItemIdGetLength(itemid);
+		tuple.t_tableOid = RelationGetRelid(relation);
+		HeapTupleCopyBaseFromPage(&tuple, page);
+
+		/*
+		 * Each non-removable tuple must be checked to see if it needs
+		 * freezing.  Note we already have exclusive buffer lock.
+		 */
+		if (heap_prepare_freeze_tuple(&tuple,
+									   relfrozenxid, relminmxid,
+									   FreezeXid, MultiXactCutoff,
+									  &frozen[nfrozen], &tuple_totally_frozen))
+			frozen[nfrozen++].offset = offnum;
+	}						/* scan along page */
+
+	/*
+	 * If we froze any tuples, mark the buffer dirty, and write a WAL
+	 * record recording the changes.  We must log the changes to be
+	 * crash-safe against future truncation of CLOG.
+	 */
+	if (nfrozen > 0)
+	{
+		int			i;
+
+		START_CRIT_SECTION();
+
+		MarkBufferDirty(buffer);
+
+		/* execute collected freezes */
+		for (i = 0; i < nfrozen; i++)
+		{
+			ItemId		itemid;
+			HeapTupleHeader htup;
+
+			itemid = PageGetItemId(page, frozen[i].offset);
+			htup = (HeapTupleHeader) PageGetItem(page, itemid);
+
+			heap_execute_freeze_tuple_page(page, htup, &frozen[i]);
+		}
+
+		/* Now WAL-log freezing if necessary */
+		if (RelationNeedsWAL(relation))
+		{
+			XLogRecPtr	recptr;
+
+			recptr = log_heap_freeze(relation, buffer, FreezeXid,
+									 frozen, nfrozen);
+			PageSetLSN(page, recptr);
+		}
+
+		END_CRIT_SECTION();
+	}
+
+	return nfrozen;
+}
+
+/*
+ * Ensure that given xid fits base of given page.
+ */
+bool
+heap_page_prepare_for_xid(Relation relation, Buffer buffer,
+						  TransactionId xid, bool multi)
+{
+	Page				page = BufferGetPage(buffer);
+	HeapPageSpecial		pageSpecial = HeapPageGetSpecial(page);
+	TransactionId		base;
+	bool				found;
+	ShortTransactionId	min,
+						max;
+	int					i;
+
+	if (!TransactionIdIsNormal(xid))
+		return false;
+
+	for (i = 0; i < 2; i++)
+	{
+		base = multi ? pageSpecial->pd_multi_base : pageSpecial->pd_xid_base;
+
+		/* Can we already store this xid? */
+		if (xid >= base + FirstNormalTransactionId && xid <= base + MaxShortTransactionId)
+			return false;
+
+		/* Find minimum and maximum xids in the page */
+		found = heap_page_xid_min_max(page, multi, &min, &max);
+
+		/* No items on the page? */
+		if (!found)
+		{
+			int64	delta;
+
+			delta = (int64) (xid - FirstNormalTransactionId) - (int64) base;
+
+			Assert(xid >= base + delta + FirstNormalTransactionId);
+			Assert(xid <= base + delta + MaxShortTransactionId);
+
+			heap_page_shift_base(relation, buffer, page, multi, delta);
+
+			base = multi ? pageSpecial->pd_multi_base : pageSpecial->pd_xid_base;
+			Assert(xid >= base + FirstNormalTransactionId);
+			Assert(xid <= base + MaxShortTransactionId);
+			return false;
+		}
+
+		/* Can we just shift base on the page */
+		if (xid < base + FirstNormalTransactionId)
+		{
+			int64	freeDelta = MaxShortTransactionId - max,
+					requiredDelta = (base + FirstNormalTransactionId) - xid;
+
+			/* Shouldn't consider setting base less than 0 */
+			freeDelta = Min(freeDelta, base);
+
+			if (requiredDelta <= freeDelta)
+			{
+				int64	delta = - (freeDelta + requiredDelta) / 2;
+
+				Assert(xid >= base + delta + FirstNormalTransactionId);
+				Assert(xid <= base + delta + MaxShortTransactionId);
+
+				heap_page_shift_base(relation, buffer, page, multi, delta);
+
+				base = multi ? pageSpecial->pd_multi_base : pageSpecial->pd_xid_base;
+				Assert(xid >= base + FirstNormalTransactionId);
+				Assert(xid <= base + MaxShortTransactionId);
+				return true;
+			}
+		}
+		else
+		{
+			int64	freeDelta = min - FirstNormalTransactionId,
+					requiredDelta = xid - (base + MaxShortTransactionId);
+
+			Assert(xid > base + MaxShortTransactionId);
+
+			if (requiredDelta <= freeDelta)
+			{
+				int64	delta = (freeDelta + requiredDelta) / 2;
+
+				Assert(xid >= base + delta + FirstNormalTransactionId);
+				Assert(xid <= base + delta + MaxShortTransactionId);
+
+				heap_page_shift_base(relation, buffer, page, multi, delta);
+
+				base = multi ? pageSpecial->pd_multi_base : pageSpecial->pd_xid_base;
+				Assert(xid >= base + FirstNormalTransactionId);
+				Assert(xid <= base + MaxShortTransactionId);
+				return true;
+			}
+		}
+
+		if (i == 1)
+		{
+			break;
+		}
+
+		/* Have to try freeing the page... */
+		freeze_single_heap_page(relation, buffer);
+	}
+
+	elog(ERROR, "Can't fit xid into page.");
+	return false;
+}
+
+/*
+ * Ensure that given xid fits base of given page.
+ */
+bool
+rewrite_page_prepare_for_xid(Page page, TransactionId xid, bool multi)
+{
+	HeapPageSpecial		pageSpecial = HeapPageGetSpecial(page);
+	TransactionId		base;
+	bool				found;
+	ShortTransactionId	min,
+						max;
+
+	if (!TransactionIdIsNormal(xid))
+		return false;
+
+	if (!multi)
+		base = pageSpecial->pd_xid_base;
+	else
+		base = pageSpecial->pd_multi_base;
+
+	/* Can we already store this xid? */
+	if (xid >= base + FirstNormalTransactionId && xid <= base + MaxShortTransactionId)
+		return false;
+
+	/* Find minimum and maximum xids in the page */
+	found = heap_page_xid_min_max(page, multi, &min, &max);
+
+	/* No items on the page? */
+	if (!found)
+	{
+		if (!multi)
+			pageSpecial->pd_xid_base = xid - FirstNormalTransactionId;
+		else
+			pageSpecial->pd_multi_base = xid - FirstNormalTransactionId;
+		return false;
+	}
+
+	/* Can we just shift base on the page */
+	if (xid < base + FirstNormalTransactionId)
+	{
+		int64	freeDelta = MaxShortTransactionId - max,
+				requiredDelta = (base + FirstNormalTransactionId) - xid;
+
+		if (requiredDelta <= freeDelta)
+		{
+			heap_page_shift_base(NULL, InvalidBuffer,
+				page, multi, - (freeDelta + requiredDelta) / 2);
+			return true;
+		}
+	}
+	else
+	{
+		int64	freeDelta = min - FirstNormalTransactionId,
+				requiredDelta = xid - (base + MaxShortTransactionId);
+
+		if (requiredDelta <= freeDelta)
+		{
+			heap_page_shift_base(NULL, InvalidBuffer,
+				page, multi, (freeDelta + requiredDelta) / 2);
+			return true;
+		}
+	}
+
+	elog(ERROR, "Can't fit xid into page.");
+	return false;
+}
+
+
 /*
  * Subroutine for heap_insert(). Prepares a tuple for insertion. This sets the
  * tuple header fields, assigns an OID, and toasts the tuple if necessary.
@@ -2594,7 +3065,7 @@ heap_insert(Relation relation, HeapTuple tup, CommandId cid,
  * the original tuple.
  */
 static HeapTuple
-heap_prepare_insert(Relation relation, HeapTuple tup, TransactionId xid,
+heap_prepare_insert(Relation relation, HeapTuple tup,
 					CommandId cid, int options)
 {
 	/*
@@ -2637,12 +3108,12 @@ heap_prepare_insert(Relation relation, HeapTuple tup, TransactionId xid,
 	tup->t_data->t_infomask &= ~(HEAP_XACT_MASK);
 	tup->t_data->t_infomask2 &= ~(HEAP2_XACT_MASK);
 	tup->t_data->t_infomask |= HEAP_XMAX_INVALID;
-	HeapTupleHeaderSetXmin(tup->t_data, xid);
+	tup->t_data->t_choice.t_heap.t_xmin = InvalidTransactionId;
 	if (options & HEAP_INSERT_FROZEN)
 		HeapTupleHeaderSetXminFrozen(tup->t_data);
 
 	HeapTupleHeaderSetCmin(tup->t_data, cid);
-	HeapTupleHeaderSetXmax(tup->t_data, 0); /* for cleanliness */
+	HeapTupleSetXmax(tup, 0); /* for cleanliness */
 	tup->t_tableOid = RelationGetRelid(relation);
 
 	/*
@@ -2695,8 +3166,7 @@ heap_multi_insert(Relation relation, HeapTuple *tuples, int ntuples,
 	/* Toast and set header data in all the tuples */
 	heaptuples = palloc(ntuples * sizeof(HeapTuple));
 	for (i = 0; i < ntuples; i++)
-		heaptuples[i] = heap_prepare_insert(relation, tuples[i],
-											xid, cid, options);
+		heaptuples[i] = heap_prepare_insert(relation, tuples[i], cid, options);
 
 	/*
 	 * Allocate some memory to use for constructing the WAL record. Using
@@ -2750,6 +3220,8 @@ heap_multi_insert(Relation relation, HeapTuple *tuples, int ntuples,
 										   &vmbuffer, NULL);
 		page = BufferGetPage(buffer);
 
+		heap_page_prepare_for_xid(relation, buffer, xid, false);
+
 		/* NO EREPORT(ERROR) from here till changes are logged */
 		START_CRIT_SECTION();
 
@@ -2757,7 +3229,8 @@ heap_multi_insert(Relation relation, HeapTuple *tuples, int ntuples,
 		 * RelationGetBufferForTuple has ensured that the first tuple fits.
 		 * Put that on the page, and then as many other tuples as fit.
 		 */
-		RelationPutHeapTuple(relation, buffer, heaptuples[ndone], false);
+		HeapTupleCopyBaseFromPage(heaptuples[ndone], BufferGetPage(buffer));
+		RelationPutHeapTuple(relation, buffer, heaptuples[ndone], false, xid);
 		for (nthispage = 1; ndone + nthispage < ntuples; nthispage++)
 		{
 			HeapTuple	heaptup = heaptuples[ndone + nthispage];
@@ -2765,7 +3238,8 @@ heap_multi_insert(Relation relation, HeapTuple *tuples, int ntuples,
 			if (PageGetHeapFreeSpace(page) < MAXALIGN(heaptup->t_len) + saveFreeSpace)
 				break;
 
-			RelationPutHeapTuple(relation, buffer, heaptup, false);
+			HeapTupleCopyBaseFromPage(heaptup, BufferGetPage(buffer));
+			RelationPutHeapTuple(relation, buffer, heaptup, false, xid);
 
 			/*
 			 * We don't use heap_multi_insert for catalog tuples yet, but
@@ -2884,6 +3358,10 @@ heap_multi_insert(Relation relation, HeapTuple *tuples, int ntuples,
 				bufflags |= REGBUF_KEEP_DATA;
 
 			XLogBeginInsert();
+			if (info & XLOG_HEAP_INIT_PAGE)
+			{
+				XLogRegisterData((char *) &HeapPageGetSpecial(page)->pd_xid_base, sizeof(TransactionId));
+			}
 			XLogRegisterData((char *) xlrec, tupledata - scratch);
 			XLogRegisterBuffer(0, buffer, REGBUF_STANDARD | bufflags);
 
@@ -3095,6 +3573,7 @@ heap_delete(Relation relation, ItemPointer tid,
 	tp.t_data = (HeapTupleHeader) PageGetItem(page, lp);
 	tp.t_len = ItemIdGetLength(lp);
 	tp.t_self = *tid;
+	HeapTupleCopyBaseFromPage(&tp, page);
 
 l1:
 	result = HeapTupleSatisfiesUpdate(&tp, cid, buffer);
@@ -3112,7 +3591,7 @@ l1:
 		uint16		infomask;
 
 		/* must copy state data before unlocking buffer */
-		xwait = HeapTupleHeaderGetRawXmax(tp.t_data);
+		xwait = HeapTupleGetRawXmax(&tp);
 		infomask = tp.t_data->t_infomask;
 
 		/*
@@ -3152,7 +3631,7 @@ l1:
 				 * for xmax change, and start over if so.
 				 */
 				if (xmax_infomask_changed(tp.t_data->t_infomask, infomask) ||
-					!TransactionIdEquals(HeapTupleHeaderGetRawXmax(tp.t_data),
+					!TransactionIdEquals(HeapTupleGetRawXmax(&tp),
 										 xwait))
 					goto l1;
 			}
@@ -3185,7 +3664,7 @@ l1:
 			 * Check for xmax change, and start over if so.
 			 */
 			if (xmax_infomask_changed(tp.t_data->t_infomask, infomask) ||
-				!TransactionIdEquals(HeapTupleHeaderGetRawXmax(tp.t_data),
+				!TransactionIdEquals(HeapTupleGetRawXmax(&tp),
 									 xwait))
 				goto l1;
 
@@ -3199,7 +3678,7 @@ l1:
 		 */
 		if ((tp.t_data->t_infomask & HEAP_XMAX_INVALID) ||
 			HEAP_XMAX_IS_LOCKED_ONLY(tp.t_data->t_infomask) ||
-			HeapTupleHeaderIsOnlyLocked(tp.t_data))
+			HeapTupleHeaderIsOnlyLocked(&tp))
 			result = HeapTupleMayBeUpdated;
 		else
 			result = HeapTupleUpdated;
@@ -3219,7 +3698,7 @@ l1:
 			   result == HeapTupleBeingUpdated);
 		Assert(!(tp.t_data->t_infomask & HEAP_XMAX_INVALID));
 		hufd->ctid = tp.t_data->t_ctid;
-		hufd->xmax = HeapTupleHeaderGetUpdateXid(tp.t_data);
+		hufd->xmax = HeapTupleGetUpdateXidAny(&tp);
 		if (result == HeapTupleSelfUpdated)
 			hufd->cmax = HeapTupleHeaderGetCmax(tp.t_data);
 		else
@@ -3244,7 +3723,7 @@ l1:
 	CheckForSerializableConflictIn(relation, &tp, buffer);
 
 	/* replace cid with a combo cid if necessary */
-	HeapTupleHeaderAdjustCmax(tp.t_data, &cid, &iscombo);
+	HeapTupleHeaderAdjustCmax(&tp, &cid, &iscombo);
 
 	/*
 	 * Compute replica identity tuple before entering the critical section so
@@ -3262,11 +3741,15 @@ l1:
 	 */
 	MultiXactIdSetOldestMember();
 
-	compute_new_xmax_infomask(HeapTupleHeaderGetRawXmax(tp.t_data),
+	compute_new_xmax_infomask(HeapTupleGetRawXmax(&tp),
 							  tp.t_data->t_infomask, tp.t_data->t_infomask2,
 							  xid, LockTupleExclusive, true,
 							  &new_xmax, &new_infomask, &new_infomask2);
 
+	heap_page_prepare_for_xid(relation, buffer, new_xmax,
+		(new_infomask & HEAP_XMAX_IS_MULTI) ? true : false);
+	HeapTupleCopyBaseFromPage(&tp, page);
+
 	START_CRIT_SECTION();
 
 	/*
@@ -3292,7 +3775,7 @@ l1:
 	tp.t_data->t_infomask |= new_infomask;
 	tp.t_data->t_infomask2 |= new_infomask2;
 	HeapTupleHeaderClearHotUpdated(tp.t_data);
-	HeapTupleHeaderSetXmax(tp.t_data, new_xmax);
+	HeapTupleSetXmax(&tp, new_xmax);
 	HeapTupleHeaderSetCmax(tp.t_data, cid, iscombo);
 	/* Make sure there is no forward chain link in t_ctid */
 	tp.t_data->t_ctid = tp.t_self;
@@ -3494,7 +3977,8 @@ heap_update(Relation relation, ItemPointer otid, HeapTuple newtup,
 	HeapTuple	heaptup;
 	HeapTuple	old_key_tuple = NULL;
 	bool		old_key_copied = false;
-	Page		page;
+	Page		page,
+				newpage;
 	BlockNumber block;
 	MultiXactStatus mxact_status;
 	Buffer		buffer,
@@ -3600,9 +4084,11 @@ heap_update(Relation relation, ItemPointer otid, HeapTuple newtup,
 	oldtup.t_data = (HeapTupleHeader) PageGetItem(page, lp);
 	oldtup.t_len = ItemIdGetLength(lp);
 	oldtup.t_self = *otid;
+	HeapTupleCopyBaseFromPage(&oldtup, page);
 
 	/* the new tuple is ready, except for this: */
 	newtup->t_tableOid = RelationGetRelid(relation);
+	HeapTupleCopyBaseFromPage(newtup, page);
 
 	/* Fill in OID for newtup */
 	if (relation->rd_rel->relhasoids)
@@ -3700,7 +4186,7 @@ l2:
 		 */
 
 		/* must copy state data before unlocking buffer */
-		xwait = HeapTupleHeaderGetRawXmax(oldtup.t_data);
+		xwait = HeapTupleGetRawXmax(&oldtup);
 		infomask = oldtup.t_data->t_infomask;
 
 		/*
@@ -3746,6 +4232,7 @@ l2:
 				checked_lockers = true;
 				locker_remains = remain != 0;
 				LockBuffer(buffer, BUFFER_LOCK_EXCLUSIVE);
+				HeapTupleCopyBaseFromPage(&oldtup, page);
 
 				/*
 				 * If xwait had just locked the tuple then some other xact
@@ -3754,7 +4241,7 @@ l2:
 				 */
 				if (xmax_infomask_changed(oldtup.t_data->t_infomask,
 										  infomask) ||
-					!TransactionIdEquals(HeapTupleHeaderGetRawXmax(oldtup.t_data),
+					!TransactionIdEquals(HeapTupleGetRawXmax(&oldtup),
 										 xwait))
 					goto l2;
 			}
@@ -3779,7 +4266,7 @@ l2:
 			 * subxact aborts.
 			 */
 			if (!HEAP_XMAX_IS_LOCKED_ONLY(oldtup.t_data->t_infomask))
-				update_xact = HeapTupleGetUpdateXid(oldtup.t_data);
+				update_xact = HeapTupleGetUpdateXid(&oldtup);
 			else
 				update_xact = InvalidTransactionId;
 
@@ -3827,6 +4314,8 @@ l2:
 			checked_lockers = true;
 			LockBuffer(buffer, BUFFER_LOCK_EXCLUSIVE);
 
+			HeapTupleCopyBaseFromPage(&oldtup, page);
+
 			/*
 			 * xwait is done, but if xwait had just locked the tuple then some
 			 * other xact could update this tuple before we get to this point.
@@ -3834,7 +4323,7 @@ l2:
 			 */
 			if (xmax_infomask_changed(oldtup.t_data->t_infomask, infomask) ||
 				!TransactionIdEquals(xwait,
-									 HeapTupleHeaderGetRawXmax(oldtup.t_data)))
+									 HeapTupleGetRawXmax(&oldtup)))
 				goto l2;
 
 			/* Otherwise check if it committed or aborted */
@@ -3860,7 +4349,7 @@ l2:
 			   result == HeapTupleBeingUpdated);
 		Assert(!(oldtup.t_data->t_infomask & HEAP_XMAX_INVALID));
 		hufd->ctid = oldtup.t_data->t_ctid;
-		hufd->xmax = HeapTupleHeaderGetUpdateXid(oldtup.t_data);
+		hufd->xmax = HeapTupleGetUpdateXidAny(&oldtup);
 		if (result == HeapTupleSelfUpdated)
 			hufd->cmax = HeapTupleHeaderGetCmax(oldtup.t_data);
 		else
@@ -3892,6 +4381,7 @@ l2:
 		LockBuffer(buffer, BUFFER_LOCK_UNLOCK);
 		visibilitymap_pin(relation, block, &vmbuffer);
 		LockBuffer(buffer, BUFFER_LOCK_EXCLUSIVE);
+		HeapTupleCopyBaseFromPage(&oldtup, page);
 		goto l2;
 	}
 
@@ -3901,7 +4391,7 @@ l2:
 	 * If the tuple we're updating is locked, we need to preserve the locking
 	 * info in the old tuple's Xmax.  Prepare a new Xmax value for this.
 	 */
-	compute_new_xmax_infomask(HeapTupleHeaderGetRawXmax(oldtup.t_data),
+	compute_new_xmax_infomask(HeapTupleGetRawXmax(&oldtup),
 							  oldtup.t_data->t_infomask,
 							  oldtup.t_data->t_infomask2,
 							  xid, *lockmode, true,
@@ -3920,7 +4410,7 @@ l2:
 		(checked_lockers && !locker_remains))
 		xmax_new_tuple = InvalidTransactionId;
 	else
-		xmax_new_tuple = HeapTupleHeaderGetRawXmax(oldtup.t_data);
+		xmax_new_tuple = HeapTupleGetRawXmax(&oldtup);
 
 	if (!TransactionIdIsValid(xmax_new_tuple))
 	{
@@ -3953,17 +4443,23 @@ l2:
 	 */
 	newtup->t_data->t_infomask &= ~(HEAP_XACT_MASK);
 	newtup->t_data->t_infomask2 &= ~(HEAP2_XACT_MASK);
-	HeapTupleHeaderSetXmin(newtup->t_data, xid);
 	HeapTupleHeaderSetCmin(newtup->t_data, cid);
 	newtup->t_data->t_infomask |= HEAP_UPDATED | infomask_new_tuple;
 	newtup->t_data->t_infomask2 |= infomask2_new_tuple;
-	HeapTupleHeaderSetXmax(newtup->t_data, xmax_new_tuple);
+
+	heap_page_prepare_for_xid(relation, buffer, xid, false);
+	HeapTupleCopyBaseFromPage(newtup, page);
+	HeapTupleSetXmin(newtup, xid);
+	heap_page_prepare_for_xid(relation, buffer, xmax_new_tuple,
+		(newtup->t_data->t_infomask & HEAP_XMAX_IS_MULTI) ? true : false);
+	HeapTupleCopyBaseFromPage(newtup, page);
+	HeapTupleSetXmax(newtup, xmax_new_tuple);
 
 	/*
 	 * Replace cid with a combo cid if necessary.  Note that we already put
 	 * the plain cid into the new tuple.
 	 */
-	HeapTupleHeaderAdjustCmax(oldtup.t_data, &cid, &iscombo);
+	HeapTupleHeaderAdjustCmax(&oldtup, &cid, &iscombo);
 
 	/*
 	 * If the toaster needs to be activated, OR if the new tuple will not fit
@@ -4018,7 +4514,7 @@ l2:
 		 * updating, because the potentially created multixact would otherwise
 		 * be wrong.
 		 */
-		compute_new_xmax_infomask(HeapTupleHeaderGetRawXmax(oldtup.t_data),
+		compute_new_xmax_infomask(HeapTupleGetRawXmax(&oldtup),
 								  oldtup.t_data->t_infomask,
 								  oldtup.t_data->t_infomask2,
 								  xid, *lockmode, false,
@@ -4027,6 +4523,10 @@ l2:
 
 		Assert(HEAP_XMAX_IS_LOCKED_ONLY(infomask_lock_old_tuple));
 
+		heap_page_prepare_for_xid(relation, buffer, xmax_lock_old_tuple,
+			(infomask_lock_old_tuple & HEAP_XMAX_IS_MULTI) ? true : false);
+		HeapTupleCopyBaseFromPage(&oldtup, page);
+
 		START_CRIT_SECTION();
 
 		/* Clear obsolete visibility flags ... */
@@ -4035,9 +4535,9 @@ l2:
 		HeapTupleClearHotUpdated(&oldtup);
 		/* ... and store info about transaction updating this tuple */
 		Assert(TransactionIdIsValid(xmax_lock_old_tuple));
-		HeapTupleHeaderSetXmax(oldtup.t_data, xmax_lock_old_tuple);
 		oldtup.t_data->t_infomask |= infomask_lock_old_tuple;
 		oldtup.t_data->t_infomask2 |= infomask2_lock_old_tuple;
+		HeapTupleSetXmax(&oldtup, xmax_lock_old_tuple);
 		HeapTupleHeaderSetCmax(oldtup.t_data, cid, iscombo);
 
 		/* temporarily make it look not-updated, but locked */
@@ -4200,6 +4700,12 @@ l2:
 										   bms_overlap(modified_attrs, id_attrs),
 										   &old_key_copied);
 
+	heap_page_prepare_for_xid(relation, newbuf, xid, false);
+	HeapTupleCopyBaseFromPage(heaptup, page);
+	heap_page_prepare_for_xid(relation, buffer, xmax_old_tuple,
+		(infomask_old_tuple & HEAP_XMAX_IS_MULTI) ? true : false);
+	HeapTupleCopyBaseFromPage(&oldtup, page);
+
 	/* NO EREPORT(ERROR) from here till changes are logged */
 	START_CRIT_SECTION();
 
